package uk.ac.rhul.cs2800.model;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import uk.ac.rhul.cs2800.model.exception.NoGradeAvailableException;


class StudentTest {

  private Student student;
  private Module module;
  private Grade grade;


  @BeforeEach
  void setUp() {
    student = new Student(1L, "Anna", "Angelina", "Alina", "Izzy");
    module = new Module("CS2800", "ComputerScience", false);
    grade = new Grade(85, module);
  }

  @Test
  void testAddGrade() throws NoGradeAvailableException {
    student.addGrade(grade);
    assertEquals(grade, student.getGrade(module));
  }

  @Test
  void testComputeAverage() {
    student.addGrade(new Grade(50, module));
    student.addGrade(new Grade(90, new Module("CS2800", "ComputerScience", false)));
    assertEquals(70.0, student.computeAverage(), 0.01);
  }

  @Test
  void testGetGradeThrowsExceptionWhenNoGrade() {
    Module newModule = new Module("CS2800", "ComputerScience", false);
    assertThrows(NoGradeAvailableException.class, () -> student.getGrade(newModule));
  }

  @Test
  void testRegisterModule() {
    student.registerModule(module);

    assertTrue(student.getModules().contains(module));
  }
}
